/*
 * Copyright © 2011 Linaro Limited
 *
 * This file is part of glcompbench.
 *
 * glcompbench is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * glcompbench is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with glcompbench.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Authors:
 *  Alexandros Frantzis <alexandros.frantzis@linaro.org>
 *  Jesse Barker <jesse.barker@linaro.org>
 *  Marc Ordinas i Llopis, Collabora Ltd <marc.ordinasillopis@linaro.org>
 */

#ifndef COMPOSITE_WINDOW_GLXPIXMAP_H_
#define COMPOSITE_WINDOW_GLXPIXMAP_H_

#include <X11/Xlib.h>
#ifdef USE_GLPROXY
#include <GL/glx_proxy.h>
#else
#include <GL/glx.h>
#endif
#include "composite-window-gl.h"

class CompositeWindowGLXPixmap : public CompositeWindowGL
{
public:
    CompositeWindowGLXPixmap(Display *xdpy, Window win,
                             GLXFBConfig glx_fbconfig) :
        CompositeWindowGL(xdpy, win), glx_pixmap_(0),
        glx_fbconfig_ (glx_fbconfig), glx_pixmap_bound_(false) {}
    ~CompositeWindowGLXPixmap();

    void update_texture();
    void update_texture_from_pixmap();

private:
    void release_tfp();
    GLXPixmap glx_pixmap_;
    GLXFBConfig glx_fbconfig_;
    bool glx_pixmap_bound_;
};

#endif /* COMPOSITE_WINDOW_GLXPIXMAP_H */
